.form-group {
    display: flex;
    padding: 1rem;
    flex: 1;
    //background: var(--contrast-light);

    .form-group {
        padding-right: 0;
        background: none;
    }

    &.form-group-row {
        flex-direction: row;

        .form-control-label {
            margin-right: 0.25rem;
        }
    }

    &.form-group-column {
        flex-direction: column;

        .form-group-left {
            color: white;
            margin-bottom: 0.25rem;
        }

        .form-group-right {
            margin-bottom: 0.25rem;
        }
    }
}

.form-control-label {
    display: flex;
    margin: 0.125rem 0;
    min-height: 2rem;

    &.form-control-row {
        flex-direction: row;
        align-items: center;

        .form-label {
            margin-right: 0.5rem;
        }
    }

    &.form-control-column {
        flex-direction: column;
        margin-bottom: 0.5rem;

        .form-label {
            line-height: 2rem;
        }
    }

    .form-label-align-left {
        text-align: left;
    }

    .form-label-align-right {
        text-align: right;
    }

}

.form-label {
    color: var(--text-color-dark);
    font-size: 0.875em;
}

.form-control-container {
    flex: 1;
    height: fit-content;
    margin: 0 1px;
}

div.form-control, input.form-control, textarea.form-control, table.form-control {
    text-overflow: ellipsis;
    box-sizing: border-box;

    color: var(--text-color);
    background: var(--form-control-bg);
    border: 1px solid var(--border);
    border-radius: 0.25rem;

    width: 100%;
    min-height: 2rem;

    padding: 0.5rem;
    margin: 0;
    outline: none;

    &:disabled, > :disabled {
        color: var(--text-color-dark);
        background-color: var(--contrast-light);
    }

    &:focus {
        border: 1px solid rgba(var(--prim-rgb), 0.9) !important;
    }

    span {
        margin: 0 !important;
    }
}

div.form-input-group {
    display: flex;
    align-items: center;
    flex: 1;

    outline: 0;
    padding: 0;
    margin: 0.125rem 0;

    background: rgba(var(--base-color-rgb), 0.2);
    border: 0;
    box-shadow: 0 0 0 0.7px var(--border);

    &:focus-within {
        border: 0 !important;
        box-shadow: 0 0 0 0.7px rgba(var(--prim-rgb), 0.9);
    }

    .checkbox-form, .as-container {
        flex: 1;
    }

    .as-control-container {
        background: none;
        border: none;
    }

    input {
        text-overflow: inherit;
        box-sizing: border-box;
        flex: 1;

        color: var(--text-color);

        width: 100%;
        height: 2rem;

        padding: 0.5rem;
        outline: none;
    }

    .input-append {
        border-radius: 0 0.25rem 0.25rem 0;
    }

    .input-prepend {
        border-radius: 0.25rem 0 0 0.25rem;
    }

    .input-append, .input-prepend {
        background: rgba(var(--contrast-color-rgb), 0.15);

        > span, button {
            padding: 0.5rem 0.75rem;
            box-sizing: border-box;
            display: block;
            height: 2rem;
        }

        > .as-container {
            padding: 0;

            .as-control-container {
                border-radius: 0.25rem 0 0 0.25rem;
                border: 0;
            }
        }

        & + input {
            border-radius: 0 0.25rem 0.25rem 0;
        }
    }
}

.form-control-container {
    flex: 1;

    &.required {
        color: var(--danger-color);
        position: relative;

        &::before {
            content: '*';
            position: absolute;
            left: -10px;
            top: 0.45rem;
            color: var(--danger);
            font-weight: bold;
            font-size: 1rem;
        }
    }

    &.dirty {
        position: relative;

        &::after {
            content: "";
            position: absolute;
            top: 0;
            right: 0;
            border-top: 8px solid var(--warning-color);
            border-left: 8px solid transparent;
        }
    }
}

